﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net;
using System.Diagnostics;
using System.Runtime.InteropServices;

namespace SideBar
{
    public partial class SideBarForm : ClipboardSideDockForm
    {
        string localIP, publicIP;
        long time;
        long timeUpdateClipboard;
        Worm[] worms;
        readonly Color[] wormHigh = { Color.FromArgb(64, 64, 255), Color.FromArgb(255, 0, 0), Color.FromArgb(0, 255, 0), Color.FromArgb(255, 255, 0), Color.FromArgb(255, 0, 255) };
        readonly Color[] wormLow = { Color.FromArgb(0, 0, 96), Color.FromArgb(96, 0, 0), Color.FromArgb(0, 96, 0), Color.FromArgb(64, 64, 0), Color.FromArgb(64, 0, 64) };
        int previousClipNumber;
        

        public SideBarForm()
        {
            InitializeComponent();

            //this.ClipboardActivated += RetrieveClipboard;
            //RetrieveClipboard(this, EventArgs.Empty);

            //this.Edge = AppBarEdges.Float;
        }


        private void button1_Click(object sender, EventArgs e)
        {
            /*chkClipboardStore1.Text = "";
            string str = "case Test Èxãmple. try IT!";
            string a = str.ToUpper();
            string b = str.ToLower();
            b = a;

            string para = "\n  test\n ttest\r\n xort \n\r\t\tZZZZZZZZZZZZZZZZ\n";
            para = StringAdvanced.AppendEndOfWhitespacePerLine("//", para);*/
            //this.Edge = AppBarEdges.Left;
        }

        void RetrieveClipboard(object sender, EventArgs e)
        {
            ClipboardData clipDat;
            //fixme report error
            try { clipDat = ClipboardData.ReadClipboard(); }
            catch (Exception ex) { return; }
            clipDat.FillControl(btnClipboard);
            btnClipboard.Tag = clipDat;
            timeUpdateClipboard = time + 2000;
        }

        private void picClose_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void picMinimize_Click(object sender, EventArgs e)
        {
            //fixme minimize
            //---------------toggle docking---------------
            this.Edge = AppBarEdges.Right;
            this.Refresh();
            Screen targetScreen = Screen.AllScreens[Screen.AllScreens.Length - 1];
            this.Height = targetScreen.Bounds.Height;
        }

        //fixme atribute code to owner
        //---------------
        private void GetPublicIP()
        {
            String direction = "";
            WebRequest request = WebRequest.Create("http://checkip.dyndns.org/");
            using (WebResponse response = request.GetResponse())
            using (StreamReader stream = new StreamReader(response.GetResponseStream()))
            {
                direction = stream.ReadToEnd();
            }
            
            //Search for the ip in the html
            int first = direction.IndexOf("Address: ") + 9;
            int last = direction.LastIndexOf("</body>");
            publicIP = direction.Substring(first, last - first);
        }
        //---------------

        private void GetLocalIP()
        {
            IPHostEntry host;
            localIP = "?";
            host = Dns.GetHostEntry(Dns.GetHostName());
            foreach (IPAddress ip in host.AddressList)
            {
                if (ip.AddressFamily.ToString() == "InterNetwork")
                {
                    localIP = ip.ToString();
                    return;
                }
            }
            localIP = "unknown";
        }

        private void CheckLocalIPs()
        {
            GetLocalIP();
            GetPublicIP();
        }

        private void SideBarForm_Load(object sender, EventArgs e)
        {
            //------------------------------------
            Bitmap bmp = new Bitmap(2, 2);
            bmp.SetPixel(0, 0, SystemColors.GradientInactiveCaption);
            bmp.SetPixel(0, 1, SystemColors.GradientInactiveCaption);
            bmp.SetPixel(1, 0, SystemColors.GradientActiveCaption);
            bmp.SetPixel(1, 1, SystemColors.GradientActiveCaption);
            picTitleBar.Image = bmp;
            
            this.Width = 128;
            Screen targetScreen = Screen.AllScreens[Screen.AllScreens.Length - 1];
            this.Height = targetScreen.Bounds.Height;
            this.Left = targetScreen.Bounds.Left + targetScreen.Bounds.Width - 128;
            this.Top = targetScreen.Bounds.Top;

            //dock to left side
            this.Edge = AppBarEdges.Right;

            //fixme get ips as delayed
            CheckLocalIPs();
            lblLocalIp.Text = "local: " + localIP;
            lblExternalIp.Text = "public: " + publicIP;

            picWorms.Image = new Bitmap(picWorms.Width/4, picWorms.Height/4);
            worms = new Worm[5];
            for (int itr = 0; itr < 5; itr++)
                worms[itr] = new Worm((Bitmap)picWorms.Image, wormHigh[itr], wormLow[itr]);

        }

        
        private void tmrRefresh_Tick(object sender, EventArgs e)
        {
            time = DateTime.Now.Ticks / TimeSpan.TicksPerMillisecond;

            if (picWorms.Image.Height != picWorms.Height / 4)
            {
                picWorms.Image = new Bitmap(picWorms.Width / 4, picWorms.Height / 4);
                worms = new Worm[5];
                for (int itr = 0; itr < 5; itr++)
                    worms[itr] = new Worm((Bitmap)picWorms.Image, wormHigh[itr], wormLow[itr]);
            }

            int clipNumber = GetClipboardSequenceNumber();
            if (previousClipNumber != clipNumber)
            {
                RetrieveClipboard(this, EventArgs.Empty);
                previousClipNumber = clipNumber;
            }

            if (timeUpdateClipboard > time)
            {
                if (((timeUpdateClipboard - time) / 350) % 2 == 0)
                    btnClipboard.BackColor = SystemColors.Highlight;
                else
                    btnClipboard.UseVisualStyleBackColor = true;
            }
            else
                btnClipboard.UseVisualStyleBackColor = true;

            for (int itr = 0; itr < 5; itr++)
            {
                worms[itr].Update();
            }
            picWorms.Refresh();

            lblClock.Text = DateTime.Now.ToString();
        }

        private void chkClipboardStore_CheckedChanged(object sender, EventArgs e)
        {//fixme clipboard event
            CheckBox chkMe = (CheckBox)sender;
            if (chkMe.Checked)
            {
                chkMe.Tag = btnClipboard.Tag;
                ((ClipboardData)chkMe.Tag).FillControl(chkMe);
            }
            else
            {
                ((ClipboardData)chkMe.Tag).WriteToClipboard();
                chkMe.Image = null;
                chkMe.Text = "";
            }
        }

        private void lblLocalIp_Click(object sender, EventArgs e)
        {
            Clipboard.SetText(localIP);
        }

        private void lblExternalIp_Click(object sender, EventArgs e)
        {
            Clipboard.SetText(publicIP);
        }

        void ChangeClipboardCase(int id)
        {
            try
            {
                if (Clipboard.ContainsText())
                {
                    //ClipboardData cd = ClipboardData.ReadClipboard();
                    //cd.ChangeCase(id);
                    //cd.WriteToClipboard();
                    String clipText = Clipboard.GetText();
                    Clipboard.Clear();

                    if (id == 0)
                        Clipboard.SetText(StringAdvanced.UpperCase(clipText));
                    else if (id == 1)
                        Clipboard.SetText(StringAdvanced.LowerCase(clipText));
                    else if (id == 2)
                        Clipboard.SetText(StringAdvanced.InvertCase(clipText));
                    else if (id == 3)
                        Clipboard.SetText(StringAdvanced.WhiteSpaceToChar(clipText, '_'));
                    else if (id == 4)
                        Clipboard.SetText(StringAdvanced.WordCase(clipText));
                    else if (id == 5)
                        Clipboard.SetText(StringAdvanced.SentanceCase(clipText));
                }
            }
            catch (Exception ex)
            {
                //fixme dont do nothing
            }
        }

        private void btnUpper_Click(object sender, EventArgs e)
        {
            ChangeClipboardCase(0);
        }

        private void btnLower_Click(object sender, EventArgs e)
        {
            ChangeClipboardCase(1);
        }

        private void btnInvert_Click(object sender, EventArgs e)
        {
            ChangeClipboardCase(2);
        }

        private void btnRemoveSpace_Click(object sender, EventArgs e)
        {
            ChangeClipboardCase(3);
        }

        private void btnWord_Click(object sender, EventArgs e)
        {
            ChangeClipboardCase(4);
        }

        private void btnSentance_Click(object sender, EventArgs e)
        {
            ChangeClipboardCase(5);
        }

        private void btnText_Click(object sender, EventArgs e)
        {
            //fixme dont do nothing on exceptions
            try { if (Clipboard.ContainsText()) Clipboard.SetText(Clipboard.GetText()); } catch (Exception ex) { }
        }

        private void btnComment_Click(object sender, EventArgs e)
        {
            //fixme dont do nothing on exceptions
            try { if (Clipboard.ContainsText()) Clipboard.SetText(StringAdvanced.AppendEndOfWhitespacePerLine("//", Clipboard.GetText())); } catch (Exception ex) { }
        }

        private void btnTag_Click(object sender, EventArgs e)
        {
            string line = "//" + txtProject.Text + " - " + txtName.Text + "\n";
            line += StringAdvanced.AppendStartLinePerLine(txtComment.Text, "//");
            Clipboard.SetText(line);
        }

        private void lblClock_Click(object sender, EventArgs e)
        {
            Clipboard.SetText(this.Text);
        }

        //future plans

        //xml
        /*
        <SegmentList>
         <Segment type = button group>
          
         </Segment>
         <Segment>...</Segment>
        </SegmentList>
        Segment Types: ip addresses, button group, project paste, clipboard, other
        IP addresses
        <IP Label desiredaddress=""> internal, virtual, other
        Button group even number of buttons
        <button action="" text="" />
        Other:
        Project Paste
        
        
        */

        //  Cases
        //lower
        //UPPER
        //underscore_words
        //Word Upper
        //Sentace upper
        //invERT
        //
        //coding case: variable
        //coding case: property
        //coding case: const
        //coding case: function
        //coding case: class
        //coding case: comment
        //coding case: ??other??
        //coding case: as "string"
        //
        //Other
        //Tabs<->Spaces
        //
        //  TOYS
        //???Zaglo???


        //Google it



    }
}
