﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;

namespace SideBar
{
    public static class StringAdvanced
    {
        public static string UpperCase(string str)
        {
            return str.ToUpper();
        }


        public static string LowerCase(string str)
        {
            return str.ToLower();
        }


        public static string InvertCase(string str)
        {
            char[] caseSwappedChars = new char[str.Length];

            for(int i = 0; i < caseSwappedChars.Length; i++)
            {
                char c = str[i];
                if(char.IsLetter(c))
                    caseSwappedChars[i] = char.IsUpper(c) ? char.ToLower(c) : char.ToUpper(c);
                else
                    caseSwappedChars[i] = c;
            }

            return new string(caseSwappedChars);
        }


        public static string Underscore(string str)
        {
            char[] caseWhitespaceConvert = new char[str.Length];
            char[] lineEnders = { '\r', '\n' };
            int pos = 0;
            bool previousSpace = false;

            for (int i = 0; i < caseWhitespaceConvert.Length; i++)
            {
                char c = str[i];
                if (char.IsWhiteSpace(c) && !lineEnders.Contains(c))
                {
                    if (!previousSpace)
                    {
                        caseWhitespaceConvert[pos++] = '_';
                        previousSpace = true;
                    }
                }
                else
                {
                    caseWhitespaceConvert[pos++] = c;
                    previousSpace = false;
                }
            }

            return new string(caseWhitespaceConvert, 0, pos);
        }


        public static string WordCase(string str)
        {
            char[] wordCaseChars = new char[str.Length];
            bool nonLetter = true;
            for (int i = 0; i < wordCaseChars.Length; i++)
            {
                char c = str[i];
                if (char.IsLetter(c))
                {
                    if (nonLetter)
                    {
                        nonLetter = false;
                        wordCaseChars[i] = char.ToUpper(c);
                    }
                    else
                        wordCaseChars[i] = char.ToLower(c);
                }
                else
                {
                    wordCaseChars[i] = c;
                    nonLetter = true;
                }
            }
            return new string(wordCaseChars);
        }


        public static string SentanceCase(string str)
        {
            char[] wordCaseChars = new char[str.Length];
            char[] sentanceEnders = { '!', '?', '.', };
            bool endSentance = true;
            for (int i = 0; i < wordCaseChars.Length; i++)
            {
                char c = str[i];
                if (char.IsLetter(c))
                {
                    if (endSentance)
                    {
                        endSentance = false;
                        wordCaseChars[i] = char.ToUpper(c);
                    }
                    else
                        wordCaseChars[i] = char.ToLower(c);
                }
                else
                {
                    wordCaseChars[i] = c;
                    if (sentanceEnders.Contains(c))
                        endSentance = true;
                }
            }

            return new string(wordCaseChars);
        }

        public static string StripWhiteSpace(string str)
        {
            char[] wordCaseChars = new char[str.Length];
            int pos = 0;
            
            for (int i = 0; i < wordCaseChars.Length; i++)
            {
                char c = str[i];
                if (!char.IsWhiteSpace(c))
                {
                    wordCaseChars[pos++] = c;
                }
            }
            
            return new string(wordCaseChars, 0, pos);
        }

        public static string WhiteSpaceToChar(string str, char replacement)
        {
            char[] caseWhitespaceConvert = new char[str.Length];
            char[] lineEnders = { '\r', '\n' };
            int pos = 0;
            bool previousSpace = false;

            for (int i = 0; i < caseWhitespaceConvert.Length; i++)
            {
                char c = str[i];
                if (char.IsWhiteSpace(c) && !lineEnders.Contains(c))
                {
                    if (!previousSpace)
                    {
                        caseWhitespaceConvert[pos++] = replacement;
                        previousSpace = true;
                    }
                }
                else
                {
                    caseWhitespaceConvert[pos++] = c;
                    previousSpace = false;
                }
            }

            return new string(caseWhitespaceConvert, 0, pos);
        }

        public static int findNonInstace(int start, string str, char[] charList)
        {
            int pos = start;
            if (pos >= str.Length)
                return -1;
            while (charList.Contains(str[pos++]))
            {
                if (pos >= str.Length)
                    return -1;
            }
            return pos-1;
        }

        public static int findInstace(int start, string str, char[] charList)
        {
            int pos = start;
            if (pos >= str.Length)
                return -1;
            while (!charList.Contains(str[pos++]))
            {
                if (pos >= str.Length)
                    return -1;
            }
            return pos-1;
        }

        //
        //line appends --------------------------------------------------------------
        //

        public static string AppendEndOfWhitespacePerLine(string appendStr, string str)
        {
            char[] WhiteSpace = { ' ', '\0', '\t', '\r', '\n' };
            char[] EndOfLine = { '\r', '\n' };
            string newStr = str;
            int position = 0;

            //find end of white space insert "//" find next end of line
            while (true)
            {
                position = findNonInstace(position, newStr, WhiteSpace);
                if (position == -1) return newStr;

                newStr = newStr.Insert(position, appendStr);
                position = position + appendStr.Length + 1;
                if (position >= newStr.Length) return newStr;//fencepost??

                position = findInstace(position, newStr, EndOfLine);
                if (position == -1) return newStr;
            }
        }

        public static string AppendStartLinePerLine(string appendStr, string str)
        {
            return "";
        }

        public static string AppendEndOfLinePerLine(string appendStr, string str)
        {
            return "";
        }

        //lower
        //UPPER
        //underscore_words
        //Word Upper
        //Sentace upper
        //invERT

        //cammel case
    }
}
