﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Windows.Forms;

namespace SideBar
{
    class Worm
    {
        static Random RAND = new Random((int)DateTime.Now.Ticks);
        
        int x, y, dir, steps;
        Bitmap bmp;
        Color high, low;
        public float value;

        public Worm(Bitmap bmp, Color high, Color low)
        {
            this.bmp = bmp;
            x = RAND.Next(bmp.Width);
            y = RAND.Next(bmp.Height);
            steps = RAND.Next(30);
            dir = RAND.Next(4);
            this.high = high;
            this.low = low;
            value = (float)RAND.NextDouble();
        }

        public void Update()
        {
            int r,g,b;
            r = (int)(high.R * value + low.R * (1-value));
            g = (int)(high.G * value + low.G * (1-value));
            b = (int)(high.B * value + low.B * (1-value));
            Color color = Color.FromArgb(255, r, g, b);

            for (int itr = 0; itr < 2; itr++)
            {
                if (dir == 0) x++;
                else if (dir == 1) x--;
                else if (dir == 2) y++;
                else if (dir == 3) y--;

                if (x < 0) x = bmp.Width - 1;
                if (x >= bmp.Width) x = 0;
                if (y < 0) y = bmp.Height - 1;
                if (y >= bmp.Height) y = 0;

                bmp.SetPixel(x, y, color);
            }

            value += (float)(RAND.NextDouble() * 0.20 - 0.1);
            if (value < 0) value = 0;
            if (value > 1) value = 1;

            if (steps-- <= 0)
            {
                steps = RAND.Next(15) + RAND.Next(15) + 5;
                if (dir < 2)
                    dir = RAND.Next(2) + 2;
                else
                    dir = RAND.Next(2);
            }
        }
    }
}
